////////////////////////////////////////////////////////////////////////////////
//
//   ALARM_EASY_V3.C
//
//  ALARME 1 ZONA - C/ CONTROLE REMOTO  VIA RF USANDO PIC 12F675
//  DEVER SER USADO RECEPTOR COMERCIAL NA MESMA FREQUENCIA DO TRANSMISSOR (TX)
//  CARACTERISTICAS:
//  ACEITA CHAVEIRINHOS COM CI HCS200...301/PT2240B/PT2262 E HT6P20B POR
//  ALTERAR A OPO DE USURIO E RECOMPILAR ESTE PROGRAMA.
//  OPO PARA DISPARO CONTINUO OU DISPARO TEMPORIZADO.
//  OPO PARA DISPARO UNICO OU REARMAVEL.
//  AO LIGAR PRODUZ 1 TOQUE DE SIRENE E 2 TOQUES  AO DESLIGAR.
//  LED MONITOR DE ON/OFF PISCANTE (AUMENTA FREQUENCIA APS DISPARO);
//
//  ALTERE CONFORME A NECESSIDADE E RECOMPILE COM COMPILADOR CCS C.
//  AUTOR:  CLUDIO LRIOS
//  INCIO: 25/11/2013    TRMINO: 26/11/2013
//  ATUALIZADO:05/12/2013
//  ATUALIZADO:03/07/2014 //RETIRADO BUGS (DIFICULDADE PARA DAR TOQUES)
//  LIBERADO USO PARA FINS DIDTICOS APENAS.
//  SUJEITO A BUGS AINDA NO OBSERVADOS EM USO. MONTAGEM REALIZADA E TESTADA
//  SOMENTE EM  PLACA DE PROTOBOARD.
//==============================================================================
//                 DEFINIOES DO USURIO
//==============================================================================
//ESCOLHA DO MICROCONTROLADOR:
// Para usar o PIC12F675, descomente o abaixo e comente para usar o 12F629



      #define  F675



//==============================================================================
//ESCOLHA O TIPO DE CI DO TRANSMISSOR:
// O transmissor poder ter qualquer dos integrados abaixo:
//   PT2240B  /  PT2262  /   HT6P20B
//Descomente o CHIP desejado e comente os outros usando '//'.



 //      #DEFINE  CHIP_PT2240B
 //   #DEFINE  CHIP_PT2262
     #DEFINE  CHIP_HT6P20B
 //   #DEFINE  CHIP_HCS


// OBS: Apenas um poder estar descomentado, sob pena de no funcionar.
//==============================================================================
// ESCOLHA SE A SIRENE DESLIGAR APS UM TEMPO DETERMINADO PELA CONSTANTE
// TMAX-SIRENE , OU SE FICAR DISPARADO AT ACIONAR O CONTROLE REMOTO.
// DESCOMENTE PARA  DESLIGAR APOS UM TEMPO E COMENTE PARA MANTER LIGADO DIRETO:
//


      #DEFINE  DESLIGA_SIRENE_APOS_TEMPO

//
//==============================================================================
// ESCOLHA SE DEVER SER UM UNICO DISPARO OU  DISPARO CONTINUO.
// O UNICO DISPARO FAR CESSAR A SIRENE APS O TEMPO DETERMINADO E SOMENTE DIS
// PARAR NOVAMENTE SE HOUVER UM REARME COM O CONTROLE REMOTO.
// NO MODO CONTINUO, SE HOUVER NOVO ACIONAMENTO DO SENSOR IR DISPARAR A SIRENE
// DESCOMENTE PARA UNICO DISPARO E COMENTE PARA MODO DISPARO CONTINUO.


//      #DEFINE  UNICO_DISPARO


// OBS.PARA FUNCIONAR ESTA OPO, TER QUE ESTAR DESCOMENTADO O DEFINE ANTERIOR.
//==============================================================================
//ESCOLHA A SINALIZAO DE ON/OFF NA SIRENE (TOQUES)

        #DEFINE NORMAL  // 1 TOQUE PARA LIGAR E 2 PARA DESLIGAR

//DESCOMENTE PARA 1 TOQUES PARA LIGAR E 2 PARA DESLIGAR
//COMENTE PARA 2 TOQUES PARA LIGAR E 1 PARA DESLIGAR

//==============================================================================
//ESCOLHA A SINALIZAO DE ON/OFF NA SIRENE (TOQUES)

        #DEFINE TOQUE_RAPIDO  // TOQUES RAPIDOS

//DESCOMENTE PARA TOQUES RPIDOS DE SINALIZAO ON/OFF
//COMENTE TOQUE NORMAIS  DE SINALIZAO ON/OFF


//==============================================================================
//     NOTA IMPORTANTE  PARA OBTER O FUNCIONAMENTO DESTE SOFTWARE
//==============================================================================
// ATENO: CERTIFIQUE DE EXISTIR O BYTE DE CALIBRAO NO ENDEREO 3FFH DA FLASH
// Caso tenha sido APAGADO acidentalmente, ao ligar, aps a programao do pic,
// NO funcionar. O programa ir fazer um 'call'para buscar o byte de calibra-
// o, mas no encontrar a instruo de retorno 'retlw xx'. Isto far o pro-
// grama se perder, resetando continuamente.
// COMO SABER SE TENHO O BYTE DE CALIBRAO NO PIC?
// LENDO A FLASH COM UM PROGRAMADOR, DEVER SER ENCONTRADO NO ENDEREO 0X3FF, UM
// VALOR COMEANDO COM 34 SEGUIDO DE 2 DIGITOS. EX. 3480. (34=RETLW 80= LITERAL
// QUE SER RETORNADO EM 'W' PARA CARGA DO REGISTRADOR '0SCCAL'.



//      #define PERDI_BYTE_CALIBRACAO



//Descomente o acima se voc tem um pic que foi apagado o byte de calibrao.
//Ser substituido por valor padro que permita a operao do circuito.
//
//==============================================================================

//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//
//           FIM DAS DEFINIES DO USURIO
//
//    Obs. No altere o programa a seguir, a menos que saiba o que est fazendo
//
////////////////////////////////////////////////////////////////////////////////

//==============================================================================
//
//          DEFINIES GERAIS  DO  PROGRAMA
//
//==============================================================================
#ifdef   F675
#include <12F675.h>         // includes
#else
#include <12F629.h>         // includes
#endif

#ignore_warnings 203   //desconsidera mensagem de 'condition always true'

#fuses INTRC_IO,NOWDT,NOPROTECT, MCLR ,BROWNOUT, PUT  // palavra  configurao
#use delay(clock=4000000)  // clock para 4 mhz
#use fast_io(A)  //  sentido das portas feita pelo programador
#ifdef UNICO_DISPARO
  #ifndef DESLIGA_SIRENE_APOS_TEMPO
   #define DESLIGA_SIRENE_APOS_TEMPO //certifica de usar
  #endif
#endif

#ifdef  PERDI_BYTE_CALIBRACAO  // calibrao do oscilador interno do pic
#ROM  0X3FF = {0X34FC}//mxima freq= 0x34fc ;mdia=0x3480; minima=0x3400
#endif

#BYTE   GPIO = 0X05
#bit    led_onoff = 0X05.1  // PINO 6
#bit    sirene    = 0X05.4  // PINO 3
//------------------------------------------------------------------------------
// TRIS-STATE      GPIO  543210
byte const  TRIS_LED = 0b101100; //SENTIDO DAS PORTAS P/ ACENDER LED 'LEARN'
byte const  TRIS_BOT = 0b101101; //SENTIDO DAS PORTAS P/ LER BOTO 'LEARN'
//==============================================================================
#define sensor PIN_A2   //pino 5
#define RFIN   PIN_A5 	// pino 2
#define BOT    PIN_A0 	// boto 'learn'
#define LED    PIN_A0 	// led 'learn'
#byte   TRISIO = 0X85
#byte   timer0 = 0x01   // declara timer 0

//flags
#byte   flags  = 0x5e    //registrador para flags gerais
#byte   flags1 = 0x5f    //registrador para flags gerais

#define  flag_h      flags,0 // flags usados na recepo do sinal pt2240b
#define  flag_l      flags,1
#define  flag_first  flags,2
#define  flag_aux    flags,3
#define  flag_rok    flags,4
#define  flag_acao   flags,5
#define  flag_gr     flags,6

#define  flag_1toq   flags1,0
#define  flag_2toq   flags1,1
#define  flag_ton    flags1,2
#define  flag_on     flags1,3
#define  flag_disp   flags1,4
#define  flag_unica  flags1,5
#define  flag_inv    flags1,6

//variavis globais
int8 hc,lc,qb,tm1,tm2,tm3,tl1,tl2,ts1,ts2,ts3,tok,botoes, snumber_lsb;
#locate  hc=0x49
#locate  lc=0x4a
#locate  qb=0x4b
#locate  snumber_lsb =0x3f //antes do buffer (somente hcs)
int8    buffer[3]= {0,0,0};
int8    sbuffer[3]={0,0,0};
#locate  buffer=0x40
#locate  sbuffer=0x43


#ifdef CHIP_HT6P20B
byte const  tmax_ht= 80; //somente ht6p20b
#endif

#ifndef CHIP_HCS
#ifndef CHIP_HT6P20B
byte const  tmax= 80;// somente pt2240b e pt2262
#endif
#endif

#ifdef CHIP_HCS
byte const  tmax_hcs= 20 ;//somente hcs (intervalo apos cabealho)
#endif

byte const  TMAX_LED=0x03; //20SEG DE LED LEARN ACESO APS APERTAR BOTO 'LEARN'
byte const  TMAX_REP = 0x10;//tempo q/ flag_on fica ligado com boto sempre on
byte const  TMAX_SIRENE = 8*(5);//sirene ligada (tempo em min. entre parenteses)



//==============================================================================
//   DECLARAO DE PROTTIPOS DE SUBROTINAS E FUNES
//==============================================================================
void init_ram();
void acionar ();
int procura_3bytes_gravados_eeprom (int *pont);
void reset_rx ();
int procura_3bytes_livres_eeprom () ;
void grava_3bytes_eeprom (int address_init, int *pont);
void apagar_eeprom();
void toques( int c);





//==============================================================================
///////////////////////////////////////////////////////////////////////////////
//                    ROTINA PRINCIPAL
////////////////////////////////////////////////////////////////////////////////
//==============================================================================

//==============================================================================
//   INICIALIZAO DE PORTAS E REGISTRADORES
//==============================================================================

void main(){
   #ifdef  F675
   setup_adc_ports(no_analogs);  //somente pic12f675
   SETUP_ADC(ADC_OFF); //DESLIGA ADC
   #endif
   setup_comparator(nc_nc_nc_nc); // desliga comparadores
   setup_counters (RTCC_INTERNAL,RTCC_DIV_1);   //timer 0 interno /1
   ENABLE_INTERRUPTS(int_timer0); // liga interrupo por overflow do timer0
   enable_interrupts(GLOBAL);   //  liga interrupo geral
   PORT_A_PULLUPS(TRUE);
   init_ram();
//==============================================================================
//   LOOP  PRINCIPAL DE REPETIO
//==============================================================================

   while (TRUE) {

    int a;


//==============================================================================
//   TESTA ENTRADA DOS SENSORES, SE ALGUM FOI ACIONADO
//==============================================================================
    if((input(sensor))&& bit_test(flag_on) && !bit_test(flag_unica))
    { bit_set(flag_disp);
      bit_set(flag_inv);
      ts1=0;
      ts2=0;
      ts3=0;
     } //testa entrada e aciona o flag


    if(bit_test(flag_disp)){
      sirene=1; // aciona sirene
      #ifdef UNICO_DISPARO
      bit_set(flag_unica);
      #endif
      }
      else{
      if(!bit_test(flag_1toq))  sirene=0;
      }


//==============================================================================
//   TESTA BOTO 'LEARN' SE FOI APERTADO
//==============================================================================

       TRISIO= TRIS_BOT;// ajusta trisio
       if(!input(bot)){
            tm3=0;    //reseta contadores de apagamento do led 'learn' em
            tm2=0;    //modo de gravao de tx
            tm1=0;
            bit_set(flag_gr); //aciona flag p/ gravao (ir ligar led 'learn')
            for (a=0;!input(bot);a++) {
               delay_ms(50);
               if(a==100){
                  apagar_eeprom();
                  bit_clear(flag_gr);
                  TRISIO= TRIS_LED;// ajusta trisio=saida p/ led
                  for(a=0;a<5;a++){
                     output_low(LED);
                     delay_ms(250);
                     output_high(LED);
                     delay_ms(250);
                     }
                   break;
                  }
            }
        }
 //=============================================================================
 // liga led 'learn' em modo de gravao de TX
 //=============================================================================
       TRISIO= TRIS_LED;// ajusta trisio=saida p/ led
       if(bit_test(flag_gr)){
         output_low(LED);
       }
       else
       {
         output_high(LED);
       }

//==============================================================================
//   SALVA A PRIMEIRA RECEPO PARA PODER COMPARAR COM A PRXIMA
//==============================================================================

        if(!bit_test(flag_first) && bit_test(flag_rok)){
      for(a=0;a<3;a++) sbuffer[a]=buffer[a];  //salva a primeira recepo
      for(a=0;a<3;a++) buffer[a]=0;  //zera buffer
      bit_set(flag_first);  //seta bit de primeira recepo
      bit_clear(flag_rok);
      }
//==============================================================================
//   COMPARA A PRIMEIRA RECEPO COM A SEGUNDA - ACIONA SE IGUAIS
//==============================================================================

      if(bit_test(flag_first) && bit_test(flag_rok) ){
         for(a=0;(a<3) && (sbuffer[a]==buffer[a]);a++){
            if (a==2) {acionar();} //temos uma recepo correta, acionar sadas
         }
      bit_clear(flag_first);  //zera bit de primeira recepo
      bit_clear(flag_rok);
     }
//==============================================================================
//         fim da rotina de recepo pt2240b
//==============================================================================
   }// while (TRUE)
}//void main()











//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//
//          SUBROTINAS E FUNES  DO PROGRAMA
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================




//==============================================================================
//   INICIALIZAO DE REGISTRADORES NA RAM
//==============================================================================
void init_ram(){

   TRISIO= TRIS_BOT;// ajusta trisio

   #IFDEF   chip_hcs
   qb=64;
   #ELSE
   qb=24;
   #ENDIF
   lc,hc,tm1,tm2,tm3,flags,flags1=0;
   GPIO=0;
   flags1=0;
   flags=0;
   tok=0;
}
//

//==============================================================================
//   APAGAR EEPROM
//==============================================================================
void apagar_eeprom(){ int a; for(a=0;a<128;a++) write_eeprom(a,0xff); }

//==============================================================================
//   GRAVAR  TX RECEBIDO NA EEPROM
//==============================================================================
void grava_3bytes_eeprom (int address_init, int *pont){

// onde int_addres = endereo inicial da gravao
// *pont = endereo inicial da informao (3 bytes seguidos)
 int a;
 for (a=0;a<3;++a){  // copia buffer para sbuffer
     write_eeprom(address_init + a,*pont++);
    // ++pont;
     }
}
//==============================================================================
//   LOCALIZA ENDEREO LIVRE NA EEPROM PARA GRAVAR TX RECEBIDO
//==============================================================================
int procura_3bytes_livres_eeprom () {

 int a;
   for (a=0;a<128;a+=3){  // copia buffer para sbuffer
     if(read_eeprom(a)==0xff){
        if(read_eeprom(a+1)==0xff) {
           if(read_eeprom(a+2)==0xff) {
              return  a;
              }
           }
        }
     }
   return 0xff;
  }
//==============================================================================
//   LOCALIZA TX RECEBIDO SE GRAVADO NA EEPROM
//==============================================================================
int procura_3bytes_gravados_eeprom (int *pont) {

 int a;

 for (a=0;a<123;a+=3){  //
     if(read_eeprom(a)==*pont){
        if(read_eeprom(a+1)==*(pont +1)) {
           if(read_eeprom(a+2)==*(pont+2)) {
               return  0xaa;
           }
        }
     }
  }
  return 0xff;
}

//==============================================================================
//   TX RECEBIDO ENCONTRADO NA EEPROM - ACIONAR SADAS
//==============================================================================

void  acionar  (){
   int a;

   //acrescentar para impedir recepo ffffff
   if((buffer[0]==0xff) &&  (buffer[1]==0xff) &&(buffer[0]==0xff)) {
   for(a=0;a<3;++a) buffer[a]=0; //elimina endereo ffffff
    }
    //

   if(procura_3bytes_gravados_eeprom(&buffer[0])==0xaa){
   tl1=0;
   tl2=0;//reseta contadores de tempo de saidas ligadas
   ts3=0; ts2=0; ts1=0;
   tok=0;
   bit_clear(flag_gr);//reseta flag de gravao
      if (!bit_test(flag_ton)){
         if(bit_test(flag_on)) {
            bit_clear(flag_on);
            bit_clear(flag_disp);
            bit_clear(flag_inv);
           
            #IFDEF NORMAL
            bit_clear(flag_1toq);
            bit_set(flag_2toq);
            #ELSE
            bit_clear(flag_2toq);
            bit_set(flag_1toq);
            #ENDIF
            }
            else { bit_set(flag_on);
            #IFDEF NORMAL
            bit_clear(flag_2toq);
            bit_set(flag_1toq);
            #ELSE
            bit_clear(flag_1toq);
            bit_set(flag_2toq);
            
            #ENDIF
            }
       bit_set(flag_ton);
       }

   bit_clear(flag_unica);
   botoes=0;


   }

//==============================================================================
//   TESTA SE DEVE GRAVAR O TX DESCONHECIDO QUE FOI RECEBIDO
//==============================================================================
 else
   {
    if(bit_test(flag_gr)){   //gravar na eeprom o buffer
    grava_3bytes_eeprom (procura_3bytes_livres_eeprom(),buffer);
    bit_clear(flag_gr);
    }
 }

 bit_clear(flag_first);
 bit_clear(flag_rok);  //libera nova recepo
}
//==============================================================================
//   ZERA REGISTRADORES APS RECEPO DE UM BIT
//==============================================================================
void reset_rx (){ lc=0; hc=0; bit_clear(flag_h);  bit_clear(flag_l);}
//==============================================================================



//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//                    ROTINA DE INTERRUPO DO TIMER 0
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
#int_rtcc

VOID isr(){

   timer0= 155;  // recarga para nova interrupo com 100 useg

//=============================================================================
//   GERA TOQUE  NA SIRENE
//==============================================================================
    if (bit_test(flag_1toq)){
       sirene=1;
       #IFDEF TOQUE_RAPIDO
       if(bit_test(ts2,3))
       #ELSE
       if(bit_test(ts2,4))
       #ENDIF
       {   //
       sirene=0;
       bit_clear(flag_1toq);
        ++tok;
       }
    }


  if (bit_test(flag_2toq)){
       if ((tok==0) || (tok==2)) { bit_set(flag_1toq);}
         if(tok==1){
          #IFDEF TOQUE_RAPIDO
          if (!bit_test(ts2,3))
          #ELSE
          if (!bit_test(ts2,4))
          #ENDIF
          { ++tok;} //
         }
           if(tok==4) {bit_clear(flag_2toq);}
   }




//==============================================================================
//     PISCA LED ON/OFF SE LIGADO
//==============================================================================

   if (bit_test(flag_on)) {
      if (!bit_test(flag_inv)){
         if(bit_test(tm2,4)) {led_onoff=1;} else {led_onoff=0;}
      }
         else {if(bit_test(tm2,2)) {led_onoff=1;} else {led_onoff=0;}
         }
   }
   else
   {
      led_onoff=0;
   }
//==============================================================================
//     TEMPO QUE FICA ACESO O LED LEARN AO APERTAR BOTO LEARN
//==============================================================================

   if(++tm1==0){ if(++tm2==0) { if(++tm3>=TMAX_LED) bit_clear(flag_gr); } }

//==============================================================================
//     TEMPO PARA PERMISSO DE INVERSO DE  ON/OFF MANTENDO BOTO PRESSIONADO
//==============================================================================

     if(++tl1==0){ if(++tl2==TMAX_REP) {
      tl2=0; tl1=0;
      bit_clear(flag_ton); // permite mudana on/off
      }
     }
//==============================================================================
//     TEMPO PARA DESLIGAMENTO DA SIRENE
//==============================================================================

     if(++ts1==0){ if(++ts2==0){
       if(++ts3==TMAX_SIRENE){
       #IFDEF DESLIGA_SIRENE_APOS_TEMPO
        bit_clear(flag_disp); // desliga sirene
       #ENDIF
        ts3=0; ts2=0; ts1=0;
      #ifdef UNICO_DISPARO
      bit_set(flag_unica);
      #else
      bit_clear(flag_unica);
      #endif

      }
     }
    }

//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//
//   ROTINA DE RECEPO  DOS 24 BITS DA TRANSMISSO P/PT2240B/2262
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================
#IFNDEF  CHIP_HT6P20B  // SOMENTE PARA PT2240B E PT2262
#IFNDEF  CHIP_HCS
//==============================================================================
//   SINCRONIZANDO O FRAME PARA RECEPO
//==============================================================================

if (!bit_test(flag_rok) && input(RFIN)){
        if (lc>=tmax){ qb=24; reset_rx (); }

//==============================================================================
//   RECEBENDO UM BIT
//==============================================================================

   if(bit_test(flag_h) && bit_test(flag_l) ){
        shift_right(&buffer[0],3,(hc>lc)) ;//captura um bit recebido
        reset_rx (); //zera lc/hc/flag_h

        if (--qb==0){ qb=24; botoes=buffer[2];//salva botes

            #ifdef aprender_todos_botoes
               #ifdef CHIP_PT2240B
               buffer[2]&=0x0f; //apaga botes no buffer
               #endif
               #ifdef CHIP_PT2262
               buffer[2]&=0x00; //apaga botes no buffer
               #endif
            #endif
            bit_set(flag_rok);  // h uma recepo no buffer
            }
        }
     }


 //==============================================================================
//   CAPTURANDO INTERVALOS  '0' E '1' NOS REGISTRADORES 'LC' E 'HC'
//==============================================================================

 if (!bit_test(flag_rok)){
     if (input(RFIN)) {
      if (bit_test (flag_h)) bit_set (flag_l); //seta flag_l se flag_h for '1'
      if(++hc==0) --hc;  // mantm o mximo em 0xff
      }
      else
      {  bit_set (flag_h); // seta flag_h
      if(++lc==0) --lc;  // mantm o mximo em 0xff
      }
   }

#ENDIF
#ENDIF

//==============================================================================
////////////////////////////////////////////////////////////////////////////////
//
//   ROTINA DE RECEPO  DOS 24 BITS DA TRANSMISSO P/HT6P20B
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================

#IFDEF  CHIP_HT6P20B

   if(input(RFIN)&&(!bit_test(flag_rok))){ bit_set(flag_h); if(++hc==0) --hc; }
      else {
       if(!bit_test(flag_h)){if(++lc==0) --lc;}  // incrementa lc e limita 0xff
         else  {
         if(lc>tmax_ht) {reset_rx (); qb=24;}
         else { shift_right(&buffer[0],3,(lc>hc)) ;
             if (--qb==0){ qb=24; botoes=buffer[2];//salva botes
            #ifdef aprender_todos_botoes
            buffer[2]&=0x3f; //apaga botes no buffer
            #endif
            bit_set(flag_rok);}  // h uma recepo no buffer
            reset_rx(); }
       }
      }
 #endif
 //==============================================================================
////////////////////////////////////////////////////////////////////////////////
//
//   ROTINA DE RECEPO  DOS 64 BITS DA TRANSMISSO P/HCS (SEM HOPCODE, FIXO)
//
//   OBS. FAZENDO USO DE APENAS 24 BITS (4 BITS=BOTES + 20 DO SERIAL NUMBER ),
//   DESPREZANDO O BYTE MEDIANO DO SERIAL P/ DAR COMPATIBILIDADE C/ APRENDIZADO
//   DE TX NA MEMRIA, USANDO  3 BYTES POR CONTROLE.
//
////////////////////////////////////////////////////////////////////////////////
//==============================================================================

 #IFDEF  CHIP_HCS

   if(!input(RFIN)&&(!bit_test(flag_rok))){  if(++lc==0) --lc; bit_set(flag_l);}
      else {
       if(!bit_test(flag_l)){if(++hc==0) --hc; }  // incrementa hc e limita 0xff
         else  {
         if(lc>tmax_hcs)  {qb=64; reset_rx();}
         else { shift_right(&snumber_lsb,4,(lc>hc)) ;//desloca snumber+buffer
             if (--qb==0){ qb=64; botoes=buffer[2];//salva botes
             buffer[0]=snumber_lsb;//usa lsb do serial no lugar do byte mediano
            #ifdef aprender_todos_botoes
            buffer[2]&=0x0f; //apaga botes no buffer
            #endif
            bit_set(flag_rok);}  // h uma recepo no buffer
            reset_rx(); }
       }
      }
 #endif
}//void isr()

//==============================================================================
//   FIM   DA   ROTINA DE INTERRUPO DO TIMER 0
//==============================================================================

